<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>Departments</title>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet"
    href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <!-- Import Datatable sau jquery -->
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body class="hold-transition sidebar-mini layout-fixed">
  <div class="wrapper">

    <!-- Preloader -->

    <!-- Navbar -->
    <nav class="main-header navbar navbar-expand navbar-white navbar-light">
      <!-- Left navbar links -->
      <ul class="navbar-nav">
        <li class="nav-item">
          <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="index.html" class="nav-link">Home</a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="#" class="nav-link">Contact</a>
        </li>
      </ul>

      <!-- Right navbar links -->
      <ul class="navbar-nav ml-auto">
        <!-- Navbar Search -->
        <li class="nav-item">
          <a class="nav-link" data-widget="navbar-search" href="#" role="button">
            <i class="fas fa-search"></i>
          </a>
          <div class="navbar-search-block">
            <form class="form-inline">
              <div class="input-group input-group-sm">
                <input class="form-control form-control-navbar" type="search" placeholder="Search" aria-label="Search">
                <div class="input-group-append">
                  <button class="btn btn-navbar" type="submit">
                    <i class="fas fa-search"></i>
                  </button>
                  <button class="btn btn-navbar" type="button" data-widget="navbar-search">
                    <i class="fas fa-times"></i>
                  </button>
                </div>
              </div>
            </form>
          </div>
        </li>
      </ul>
    </nav>
    <!-- /.navbar -->

    <!-- Main Sidebar Container -->
    <aside class="main-sidebar sidebar-dark-primary elevation-4">
      <!-- Brand Logo -->
      <a href="index3.html" class="brand-link">
        <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3"
          style="opacity: .8">
        <span class="brand-text font-weight-light">Devcamp 120</span>
      </a>

      <!-- Sidebar -->
      <div class="sidebar">
        <!-- Sidebar user panel (optional) -->
        <div class="user-panel mt-3 pb-3 mb-3 d-flex">
          <div class="image">
            <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
          </div>
          <div class="info">
            <a href="#" class="d-block">Vũ Duy Dũng</a>
          </div>
        </div>

        <!-- SidebarSearch Form -->
        <div class="form-inline">
          <div class="input-group" data-widget="sidebar-search">
            <input class="form-control form-control-sidebar" type="search" placeholder="Search" aria-label="Search">
            <div class="input-group-append">
              <button class="btn btn-sidebar">
                <i class="fas fa-search fa-fw"></i>
              </button>
            </div>
          </div>
        </div>

        <!-- Sidebar Menu -->
        <nav class="mt-2">
          <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
            <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
            <li class="nav-item menu-open">
              <a href="#" class="nav-link active">
                <i class="nav-icon fas fa-tachometer-alt"></i>
                <p>
                  Dashboard
                  <i class="right fas fa-angle-left"></i>
                </p>
              </a>
              <ul class="nav nav-treeview">
                <li class="nav-item">
                  <a href="#" class="nav-link active">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Department</p>
                  </a>
                </li>
              </ul>
            </li>
          </ul>
        </nav>
        <!-- /.sidebar-menu -->
      </div>
      <!-- /.sidebar -->
    </aside>

    <!-- Content Wrapper. Contains page content -->
    <div class="content-wrapper">
      <!-- Content Header (Page header) -->
      <div class="content-header">
        <div class="container-fluid">
          <div class="row mb-2">
            <div class="col-sm-6">
              <h1 class="m-0">Department</h1>
            </div><!-- /.col -->
            <div class="col-sm-6">
              <ol class="breadcrumb float-sm-right">
                <li class="breadcrumb-item"><a href="#">Home</a></li>
                <li class="breadcrumb-item active">Department</li>
              </ol>
            </div><!-- /.col -->
          </div><!-- /.row -->
        </div><!-- /.container-fluid -->
      </div>
      <!-- /.content-header -->

      <!-- Main content -->
      <section class="content">
        <div class="container-fluid">
          <h3 class="text-center text-primary">Quản trị Department</h3>
          <div class="jumbotron container">
            <div class="row form-group">
              <label for="" class="col-sm-3">Chọn phòng ban</label>
              <div class="col-sm-9">
                <select name="select-department" id="select-department" class="form-control">
                  <option value="none">Chọn phòng ban</option>
                </select>
              </div>
            </div>
            <div class="row form-group">
              <label for="" class="col-sm-3">Mã nhân viên</label>
              <div class="col-sm-9">
                <input id="inp-employee-code" type="text" class="form-control" placeholder="Mã nhân viên">
              </div>
            </div>

            <div class="row form-group">
              <label for="" class="col-sm-3">Tên nhân viên</label>
              <div class="col-sm-9">
                <input id="inp-employee-name" type="text" class="form-control" placeholder="Tên nhân viên">
              </div>
            </div>

            <div class="row form-group">
              <label for="" class="col-sm-3">Chức vụ</label>
              <div class="col-sm-9">
                <input id="inp-position" type="text" class="form-control" placeholder="Chức vụ">
              </div>
            </div>

            <div class="row form-group">
              <label for="" class="col-sm-3">Giới tính</label>
              <div class="col-sm-9">
                <select name="select-gender" id="select-gender" class="form-control">
                  <option value="none">Chọn giới tính</option>
                  <option value="m">Nam</option>
                  <option value="f">Nữ</option>
                </select>
              </div>
            </div>

            <div class="row form-group">
              <label for="" class="col-sm-3">Ngày sinh</label>
              <div class="col-sm-9">
                <input id="inp-date-of-birth" type="date" class="form-control" placeholder="Ngày sinh">
              </div>
            </div>

            <div class="row form-group">
              <label for="" class="col-sm-3">Địa chỉ</label>
              <div class="col-sm-9">
                <input id="inp-address" type="text" class="form-control" placeholder="Địa chỉ">
              </div>
            </div>

            <div class="row form-group">
              <label for="" class="col-sm-3">Số điện thoại</label>
              <div class="col-sm-9">
                <input id="inp-phone-number" type="number" class="form-control" placeholder="Số điện thoại">
              </div>
            </div>

          
            <div class="mb-3 d-flex justify-content-around">
              <button id="btn-add" class="btn btn-success"><i class="fas fa-plus"></i>&nbsp;Thêm phòng ban</button>
              <button id="btn-update" class="btn btn-primary"><i class="fas fa-users-cog"></i>&nbsp;Cập nhật phòng
                ban</button>
              <button id="btn-delete" class="btn btn-danger"><i class="fas fa-trash"></i>&nbsp;Xóa phòng ban</button>
              <button id="btn-delete-all" class="btn btn-danger"><i class="fas fa-trash-alt"></i>&nbsp;Xóa tất cả phòng
                ban</button>
            </div>
            <div class="d-flex justify-content-around">
              <button id="btn-add-employee" class="btn btn-success"><i class="fas fa-user-plus"></i>&nbsp;Thêm nhân
                viên</button>
              <button id="btn-update-employee" class="btn btn-primary"><i class="fas fa-user-edit"></i>&nbsp;Cập nhật
                nhân viên</button>
              <button id="btn-delete-employee" class="btn btn-danger"><i class="fas fa-user-times"></i>&nbsp;Xóa nhân
                viên</button>
            </div>


          </div>

          <table id="table-employees" class="table table-bordered table-stripped table-hover">
            <thead>
              <tr>
                <th>STT</th>
                <th>Mã nhân viên</th>
                <th>Tên nhân viên</th>
                <th>Chức vụ</th>
                <th>Giới tính</th>
                <th>Ngày sinh</th>
                <th>Địa chỉ</th>
                <th>Số điện thoại</th>
              </tr>
            </thead>
            <tbody></tbody>
          </table>
          <!-- Modal Thêm phòng ban -->
          <div class="modal fade" id="modal-add-department" tabindex="-1" role="dialog"
            aria-labelledby="exampleModalLabel" aria-hidden="true">
            <div class="modal-dialog" role="document">
              <div class="modal-content">
                <div class="modal-header">
                  <h5 class="modal-title font-weight-bold" id="exampleModalLabel">Thêm phòng ban</h5>
                  <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                  </button>
                </div>
                <div class="modal-body">
                  <div class="row form-group">
                    <lablel class="col-sm-4 font-weight-bold">Mã phòng ban</lablel>
                    <div class="col-sm-8">
                      <input id="inp-department-code-add" type="text" class="form-control">
                    </div>
                  </div>

                  <div class="row form-group">
                    <lable class="col-sm-4 font-weight-bold">Tên phòng ban</lable>
                    <div class="col-sm-8">
                      <input id="inp-department-name-add" type="text" class="form-control">
                    </div>
                  </div>

                  <div class="row form-group">
                    <lable class="col-sm-4 font-weight-bold">Nghiệp vụ</lable>
                    <div class="col-sm-8">
                      <input id="inp-major-add" type="text" class="form-control">
                    </div>
                  </div>
                  <div class="row form-group">
                    <lable class="col-sm-4 font-weight-bold">Giới thiệu</lable>
                    <div class="col-sm-8">
                      <input id="inp-introduce-add" type="text" class="form-control">
                    </div>
                  </div>
                </div>
                <div class="modal-footer">
                  <button id="btn-confirm-add" type="button" class="btn btn-success">Thêm mới</button>
                  <button type="button" class="btn btn-secondary" data-dismiss="modal">Hủy bỏ</button>
                </div>
              </div>
            </div>
          </div>

          <!-- Modal cập nhật thông tin phòng ban -->
          <div class="modal fade" id="modal-update-department" tabindex="-1" role="dialog"
            aria-labelledby="exampleModalLabel" aria-hidden="true">
            <div class="modal-dialog" role="document">
              <div class="modal-content">
                <div class="modal-header">
                  <h5 class="modal-title font-weight-bold" id="exampleModalLabel">Cập nhật phòng ban</h5>
                  <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                  </button>
                </div>
                <div class="modal-body">
                  <div class="row form-group">
                    <lablel class="col-sm-4 font-weight-bold">Mã phòng ban</lablel>
                    <div class="col-sm-8">
                      <input id="inp-department-code-update" type="text" class="form-control">
                    </div>
                  </div>

                  <div class="row form-group">
                    <lable class="col-sm-4 font-weight-bold">Tên phòng ban</lable>
                    <div class="col-sm-8">
                      <input id="inp-department-name-update" type="text" class="form-control">
                    </div>
                  </div>

                  <div class="row form-group">
                    <lable class="col-sm-4 font-weight-bold">Nghiệp vụ</lable>
                    <div class="col-sm-8">
                      <input id="inp-major-update" type="text" class="form-control">
                    </div>
                  </div>
                  <div class="row form-group">
                    <lable class="col-sm-4 font-weight-bold">Giới thiệu</lable>
                    <div class="col-sm-8">
                      <input id="inp-introduce-update" type="text" class="form-control">
                    </div>
                  </div>
                </div>
                <div class="modal-footer">
                  <button id="btn-confirm-update" type="button" class="btn btn-primary">Cập nhật</button>
                  <button type="button" class="btn btn-secondary" data-dismiss="modal">Hủy bỏ</button>
                </div>
              </div>
            </div>
          </div>
        </div>
      </section>
      <!-- /.content -->

      <!-- Modal delete phòng ban -->
      <div class="modal fade" id="modal-delete-department" tabindex="-1" role="dialog"
        aria-labelledby="exampleModalLabel" aria-hidden="true">
        <div class="modal-dialog" role="document">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title" id="exampleModalLabel">Xác nhận</h5>
              <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <span aria-hidden="true">&times;</span>
              </button>
            </div>
            <div class="modal-body">
              <h5>Bạn có chắc chắn muốn xóa phòng ban này?</h5>
            </div>
            <div class="modal-footer">
              <button id="btn-confirm-delete" type="button" class="btn btn-danger">Xác nhận</button>
              <button type="button" class="btn btn-secondary" data-dismiss="modal">Hủy bỏ</button>
            </div>
          </div>
        </div>
      </div>

      <!-- Modal delete tất cả phòng ban -->
      <div class="modal fade" id="modal-delete-all-department" tabindex="-1" role="dialog"
        aria-labelledby="exampleModalLabel" aria-hidden="true">
        <div class="modal-dialog" role="document">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title" id="exampleModalLabel">Xác nhận</h5>
              <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <span aria-hidden="true">&times;</span>
              </button>
            </div>
            <div class="modal-body">
              <h5>Bạn có chắc chắn muốn tất cả phòng ban?</h5>
            </div>
            <div class="modal-footer">
              <button id="btn-confirm-delete-all" type="button" class="btn btn-danger">Xác nhận</button>
              <button type="button" class="btn btn-secondary" data-dismiss="modal">Hủy bỏ</button>
            </div>
          </div>
        </div>
      </div>

      <!-- Modal xóa thông tin nhân viên -->
      <div class="modal fade" id="modal-delete-employee" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel"
        aria-hidden="true">
        <div class="modal-dialog" role="document">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title" id="exampleModalLabel">Xác nhận</h5>
              <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <span aria-hidden="true">&times;</span>
              </button>
            </div>
            <div class="modal-body">
              <h5>Bạn có chắc chắn muốn xóa thông tin nhân viên này không?</h5>
            </div>
            <div class="modal-footer">
              <button id="btn-confirm-delete-employee" type="button" class="btn btn-danger">Xác nhận</button>
              <button type="button" class="btn btn-secondary" data-dismiss="modal">Hủy bỏ</button>
            </div>
          </div>
        </div>
      </div>
    </div>
    <!-- /.content-wrapper -->
    <footer class="main-footer">
      <strong>Copyright &copy; 2014-2021 <a href="https://adminlte.io">AdminLTE.io</a>.</strong>
      All rights reserved.
      <div class="float-right d-none d-sm-inline-block">
        <b>Version</b> 3.2.0
      </div>
    </footer>

    <!-- Control Sidebar -->
    <aside class="control-sidebar control-sidebar-dark">
      <!-- Control sidebar content goes here -->
    </aside>
    <!-- /.control-sidebar -->
  </div>
  <!-- ./wrapper -->

  <!-- AdminLTE App -->
  <script src="dist/js/adminlte.js"></script>
  <script>
    "use strict"
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    var gListCol = ["id", "employeeCode", "employeeName", "position", "gender", "dateOfBirth", "address", "phoneNumber"];
    const gCOL_ID = 0;
    const gCOL_DEPARTMENT_CODE = 1;
    const gCOL_DEPARTMENT_NAME = 2;
    const gCOL_POSITION = 3;
    const gCOL_GENDER = 4;
    const gCOL_DATE_OF_BIRTH = 5;
    const gCOL_ADDRESS = 6;
    const gCOL_PHONE_NUMBER = 7;

    var gTableEmployee = $("#table-employees").DataTable({
      columns: [
        { data: gListCol[gCOL_ID] },
        { data: gListCol[gCOL_DEPARTMENT_CODE] },
        { data: gListCol[gCOL_DEPARTMENT_NAME] },
        { data: gListCol[gCOL_POSITION] },
        { data: gListCol[gCOL_GENDER] },
        { data: gListCol[gCOL_DATE_OF_BIRTH] },
        { data: gListCol[gCOL_ADDRESS] },
        { data: gListCol[gCOL_PHONE_NUMBER] }
      ],
      columnDefs: [
        {
          targets: gCOL_ID,
          render: function () {
            return gStt++;
          }
        },
        {
          targets: gCOL_GENDER,
          render: function (paramGender) {
            if (paramGender == "f") {
              return "Nữ";
            }
            else {
              return "Nam";
            }
          }
        }
      ]
    });
    // Biến toàn cục để lưu số thứ tự
    var gStt = 1;
    // Biến lưu id của nhân viên
    var gEmployeeId = null;
    // Biến lưu id của phòng ban
    var gDepartmentId = null;
    // Biến lưu toàn bộ phòng ban
    var gListDepartment = null;
    // Biến để lưu toàn bộ nhân viên
    var gListEmployee = null;
    // Biến để lưu hành động thực hiện với department
    var gActionDepartment = null;
    // Biến để lưu hành động thực hiện với employee
    var gActionEmployee = null;
    // Biến hành động tạo mới
    const gACTION_CREATE = "create";
    // Biến hành động cập nhật
    const gACTION_UPDATE = "update";


    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    // Thực thi sự kiện tải trang
    onPageLoading();

    // Thực thi sự kiện thay đổi phòng ban
    $("#select-department").on("change", function () {
      gDepartmentId = $("#select-department").val();
      if(gDepartmentId == "none") {
        callApiToGetListEmployee();
      }
      else {
        callApiLoadToLoadListEmployeeToTable();
      }
    });

    // Thực thi sự kiện nhấn vào row trong datatable
    $("#table-employees").on("click", "tr", function () {
      onClickTableRow(this);
    });


    // Thực thi sự kiện nhấn nút thêm mới phòng ban
    $("#btn-add").on("click", function () {
      $("#modal-add-department").modal("show");
    });


    // Hàm thực thi sự kiện nhấn nút thêm mới trong modal thêm mới phòng ban
    $("#btn-confirm-add").on("click", function () {
      onBtnCreateNewDepartment();
    });

    // Thực thi sự kiện nhấn nút cập nhật phòng ban
    $("#btn-update").on("click", function () {
      onBtnUpdateDepartmentClick();
    });

    // Thực thi sự kiện nhấn nút confirm update trong modal
    $("#btn-confirm-update").on("click", function () {
      onBtnConfirmUpdateClick();
    });

    // Thực thi sự kiện nhấn nút xóa phòng ban
    $("#btn-delete").on("click", function () {
      onBtnDeleteDepartmentClick();
    });

    // Thực thi sự kiện nhấn nút xác nhận xóa phòng ban trong modal delete
    $("#btn-confirm-delete").on("click", function () {
      callApiToDeleteDepartment();
    });

    // Thực thi sự kiện nhấn nút xóa tất cả phòng ban
    $("#btn-delete-all").on("click", function () {
      $("#modal-delete-all-department").modal("show");
    });

    // Thực thi sự kiện nhấn nút confirm xóa tất cả phòng ban
    $("#btn-confirm-delete-all").on("click", function () {
      onBtnConfirmDeleteAllDepartmentClick();
    });

    // Thực thi sự kiện nhấn nút thêm mới nhân viên
    $("#btn-add-employee").on("click", function () {
      // Kiểm tra xem đã chọn phòng ban chưa
      if (checkSelectDepartment()) {
        onBtnCreateNewEmployeeClick();
      }
    });

    // Thực thi sự kiện nhấn nút cập nhật thông tin nhân viên
    $("#btn-update-employee").on("click", function () {
      if (checkSelectDepartment) {
        if (gEmployeeId != null) {
          onBtnUpdateEmployeeClick();
        }
        else {
          alert("Vui lòng chọn nhân viên muốn cập nhật thông tin!");
        }
      }
    });

    // Thực thi sự kiện nhấn nút xóa nhân viên
    $("#btn-delete-employee").on("click", function () {
      if (gEmployeeId != null) {
        $("#modal-delete-employee").modal("show");
      }
      else {
        alert("Vui lòng chọn nhân viên muốn xóa!");
      }
    });

    // Thực thi sự kiện nhấn nút xác nhận xóa trong modal delete nhân viên
    $("#btn-confirm-delete-employee").on("click", function () {
      onBtnConfirmDeleteEmployeeClick();
    })
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
      callApiToLoadListDepartmentToSelectDepartment();
      callApiToGetListEmployee();
    }

    // Hàm xử lý sự kiện nhấn vào row trong table
    // Khi nhấn vào row thì lấy dữ liệu ra và điền vào form
    function onClickTableRow(paramRow) {
      var vDataRow = gTableEmployee.row(paramRow).data();
      gEmployeeId = vDataRow.id;
      // Gọi hàm load dữ liệu row vào form
      loadEmployeeDataToForm(vDataRow);
    }

    // Hàm xử lý sự kiện nhấn nút thêm phòng ban trong modal thêm mới
    function onBtnCreateNewDepartment() {
      gActionDepartment = gACTION_CREATE;
      var vNewDepartment = {
        departmentCode: "",
        departmentName: "",
        major: "",
        introduce: ""
      }
      // Gọi hàm lấy giá trị insert phòng ban
      getNewDepartmentData(vNewDepartment);
      console.log(vNewDepartment);
      // validate dữ liệu
      var vValidate = validateDepartmentData(vNewDepartment);
      if (vValidate) {
        // Gọi APi để thêm mới phòng ban
        callApiToCreateNewDeparment(vNewDepartment);
      }
    }

    // Hàm xử lý sự kiện nhấn nút cập nhật phòng ban
    function onBtnUpdateDepartmentClick() {
      if (checkSelectDepartment()) {
        $("#modal-update-department").modal("show");
        callApiToGetDepartmentDataById();
      }
    }

    // Hàm xử lý sự kiện nhấn nút xóa phòng ban 
    function onBtnDeleteDepartmentClick() {
      if (checkSelectDepartment()) {
        $("#modal-delete-department").modal("show");
      }
    }

    // Hàm xử lý sự kiện nhấn nút xóa nhân viên

    // Hàm xử lý sự kiện nhấn nút xác nhận xóa tất cả phòng ban trong modal xóa tất cả
    function onBtnConfirmDeleteAllDepartmentClick() {
      $.ajax({
        type: "DELETE",
        url: "http://localhost:8080/departments",
        success: function (paramRes) {
          alert("Tất cả phòng ban đã được xóa!");
          $("#modal-delete-all-department").modal("hide");
          callApiToLoadListDepartmentToSelectDepartment();
        },
        error: function (paramError) {
          alert("Xóa tất cả phòng ban thất bại, vui lòng thử lại!");
          $("#modal-delete-all-department").modal("hide");
          console.log(paramError.status);
        }
      })
    }

    // Hàm xử lý sự kiện nhấn nút cập nhật phòng ban trong modal
    function onBtnConfirmUpdateClick() {
      gActionDepartment = gACTION_UPDATE;
      var vDepartment = {
        departmentCode: "",
        departmentName: "",
        major: "",
        introduce: ""
      }
      // Gọi hàm lấy giá trị phòng ban update
      getDataUpdateDepartment(vDepartment);
      console.log(vDepartment);
      // validate dữ liệu
      var vValidate = validateDepartmentData(vDepartment);
      if (vValidate) {
        // Gọi APi để thêm mới phòng ban
        callApiToUpdateDepartment(vDepartment);
      }
    }

    // Hàm xử lý sự kiện nhấn nút tạo mới nhân viên
    function onBtnCreateNewEmployeeClick() {
      gActionEmployee = gACTION_CREATE;
      var vNewEmployee = {
        employeeCode: "",
        employeeName: "",
        position: "",
        gender: "",
        dateOfBirth: "",
        address: "",
        phoneNumber: ""
      }
      getEmployeeDataForm(vNewEmployee);
      console.log(vNewEmployee);
      var vValidate = validateEmployeeData(vNewEmployee);
      if (vValidate) {
        callApiToCreateNewEmployee(vNewEmployee);
      }
    }

    // Hàm xử lý sự kiện nhấn nút update nhân viên
    function onBtnUpdateEmployeeClick() {
      gActionEmployee = gACTION_UPDATE;
      var vEmployee = {
        employeeCode: "",
        employeeName: "",
        position: "",
        gender: "",
        dateOfBirth: "",
        address: "",
        phoneNumber: ""
      }
      getEmployeeDataForm(vEmployee);
      console.log(vEmployee);
      var vValidate = validateEmployeeData(vEmployee);
      if (vValidate) {
        callApiToUpdateEmployee(vEmployee);
      }
    }

    // Hàm xử lý sự kiện nhấn nút xóa một nhân viên
    function onBtnConfirmDeleteEmployeeClick() {
      $.ajax({
        type: "DELETE",
        url: "http://localhost:8080/employee/" + gEmployeeId,
        success: function (paramRes) {
          alert("Xóa thông tin nhân viên thành công!");
          $("#modal-delete-employee").modal("hide");
          // load lại danh sách nhân viên phòng ban đó đưa vào table
          // Lấy danh sách toàn bộ nhân viên
          callApiToGetListEmployee();
          // Reset lại form
          resetFormEmployee();
        },
        error: function (paramError) {
          console.log(paramError.status);
          alert("Xóa thông tin nhân viên thất bại, vui lòng thử lại!");
          $("#modal-delete-employee").modal("hide");
        }
      })
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // Hàm gọi API để lấy ra danh sách phòng ban đưa vào thẻ select
    function callApiToLoadListDepartmentToSelectDepartment() {
      $.ajax({
        type: "GET",
        url: "http://localhost:8080/departments",
        success: function (paramRes) {
          console.log(paramRes);
          gListDepartment = paramRes;
          loadDataToSelectDepartment(paramRes);
        },
        error: function (paramError) {
          console.log(paramError.status);
        }
      });
    }

    // Hàm gọi API để lấy danh sách toàn bộ nhân viên
    function callApiToGetListEmployee() {
      $.ajax({
        type: "GET",
        url: "http://localhost:8080/employees",
        success: function (paramRes) {
          gListEmployee = paramRes;
          loadDataToTable(paramRes);
        },
        error: function (paramError) {
          console.log(paramError.status);
        }
      });
    }

    // Hàm load dữ liệu vào thẻ select Department
    function loadDataToSelectDepartment(paramDataDepartment) {
      var vSelectDepartment = $("#select-department");
      vSelectDepartment.html("");
      $("<option>", {
        value: "none",
        text: "Chọn phòng ban"
      }).appendTo(vSelectDepartment);
      for (var bI = 0; bI < paramDataDepartment.length; bI++) {
        $("<option>", {
          value: paramDataDepartment[bI].id,
          text: paramDataDepartment[bI].departmentName
        }).appendTo(vSelectDepartment);
      }
    }

    // Hàm call Api load ra danh sách nhân viên khi chọn phòng ban
    function callApiLoadToLoadListEmployeeToTable() {
      var vDepartmentId = $("#select-department").val();
      $.ajax({
        type: "GET",
        url: "http://localhost:8080/department/" + vDepartmentId + "/employees",
        success: function (paramRes) {
          loadDataToTable(paramRes);
        },
        error: function (paramError) {
          console.log(paramError.status);
        }
      });
    }

    // Hàm load dữ liệu vào bảng nhân viên
    function loadDataToTable(paramEmployeeData) {
      gStt = 1;
      gTableEmployee.clear();
      gTableEmployee.rows.add(paramEmployeeData);
      gTableEmployee.draw();
    }

    // Hàm load thông tin nhân viên vào fomr
    function loadEmployeeDataToForm(paramEmployeeData) {
      $("#inp-employee-code").val(paramEmployeeData.employeeCode);
      $("#inp-employee-name").val(paramEmployeeData.employeeName);
      $("#inp-position").val(paramEmployeeData.position);
      var vGender;
      if (paramEmployeeData.gender = "Nam") {
        vGender = "m";
      } else {
        vGender = "f";
      }
      $("#select-gender").prop("value", vGender);
      var vDateOfBirth = formatDate(paramEmployeeData.dateOfBirth);
      $("#inp-date-of-birth").val(vDateOfBirth);
      $("#inp-phone-number").val(paramEmployeeData.phoneNumber);
      $("#inp-address").val(paramEmployeeData.address);
    }

    // Hàm chỉnh lại form của ngày tháng cho phù hợp
    function formatDate(paramDate) {
      // tách ra từng phần thông qua hàm split, sau đó sắp xếp theo kiểu của input date là yy-MM-dd"
      var vListDate = paramDate.split("-");
      return vListDate[2] + "-" + vListDate[1] + "-" + vListDate[0];
    }

    // Hàm lấy thông tin phòng ban thêm mới
    function getNewDepartmentData(paramDataDepartment) {
      paramDataDepartment.departmentCode = $("#inp-department-code-add").val();
      paramDataDepartment.departmentName = $("#inp-department-name-add").val();
      paramDataDepartment.major = $("#inp-major-add").val();
      paramDataDepartment.introduce = $("#inp-introduce-add").val();
    }

    // Hàm validate dữ liệu phòng ban
    function validateDepartmentData(paramDataDepartment) {
      if (paramDataDepartment.departmentCode == "") {
        alert("Vui lòng nhập mã phòng ban!");
        return false;
      }
      // Gọi hàm kiểm tra mã phòng ban có tồn tại hay chưa
      if (checkDuplicateDepartmentCode(paramDataDepartment.departmentCode)) {
        alert("Mã phòng ban đã tồn tại!")
        return false;
      }

      if (paramDataDepartment.departmentName == "") {
        alert("Vui lòng nhập tên phòng ban!");
        return false;
      }

      if (paramDataDepartment.major == "") {
        alert("Vui lòng nhập nghiệp vụ phòng ban!");
        return false;
      }

      if (paramDataDepartment.introduce == "") {
        alert("Vui lòng nhập lời giới thiệu phòng ban!");
        return false;
      }
      return true;
    }

    // Hàm gọi API để tạo mới 1 phòng ban
    function callApiToCreateNewDeparment(paramDataDepartment) {
      $.ajax({
        type: "POST",
        url: "http://localhost:8080/departments",
        contentType: "application/json",
        data: JSON.stringify(paramDataDepartment),
        success: function (paramRes) {
          alert("Thêm mới phòng ban thành công!");
          callApiToLoadListDepartmentToSelectDepartment();
          $("#modal-add-department").modal("hide");
          resetFormCreateNewDepartment();
        },
        error: function (paramError) {
          alert("Tạo mới phòng ban thất bại, vui lòng thử lại");
          $("#modal-add-department").modal("hide");
          console.log(paramError.status);
        }
      })
    }

    // Hàm lấy giá trị phòng ban trong modal update
    function getDataUpdateDepartment(paramDataDepartment) {
      paramDataDepartment.departmentCode = $("#inp-department-code-update").val().trim();
      paramDataDepartment.departmentName = $("#inp-department-name-update").val().trim();
      paramDataDepartment.major = $("#inp-major-update").val().trim();
      paramDataDepartment.introduce = $("#inp-introduce-update").val().trim();
    }

    // Hàm gọi API để lấy dữ liệu phòng ban thông qua ID
    function callApiToGetDepartmentDataById() {
      $.ajax({
        type: "GET",
        url: "http://localhost:8080/department/" + gDepartmentId,
        success: function (paramRes) {
          loadDepartmentDataToFormUpdate(paramRes);
        },
        error: function (paramError) {
          console.log(paramError.status);
        }
      })
    }

    // Hàm load dữ liệu phòng ban vào form update
    function loadDepartmentDataToFormUpdate(paramDataDepartment) {
      $("#inp-department-code-update").val(paramDataDepartment.departmentCode);
      $("#inp-department-name-update").val(paramDataDepartment.departmentName);
      $("#inp-major-update").val(paramDataDepartment.major);
      $("#inp-introduce-update").val(paramDataDepartment.introduce);
    }

    // Hàm gọi API để cập nhật thông tin phòng ban
    function callApiToUpdateDepartment(paramDataDepartment) {
      $.ajax({
        type: "PUT",
        url: "http://localhost:8080/department/" + gDepartmentId,
        contentType: "application/json",
        data: JSON.stringify(paramDataDepartment),
        success: function (paramRes) {
          alert("Cập nhật phòng ban thành công!");
          callApiToLoadListDepartmentToSelectDepartment();
          $("#modal-update-department").modal("hide");
        },
        error: function (paramError) {
          alert("Cập nhật phòng ban thất bại, vui lòng thử lại");
          $("#modal-update-department").modal("hide");
          console.log(paramError.status);
        }
      });
    }

    // Hàm gọi API để xóa 1 phòng ban thông qua ID
    function callApiToDeleteDepartment() {
      $.ajax({
        type: "DELETE",
        url: "http://localhost:8080/department/" + gDepartmentId,
        success: function (paramRes) {
          alert("Xóa phòng ban thành công!");
          callApiToLoadListDepartmentToSelectDepartment();
          $("#modal-delete-department").modal("hide");
          resetFormEmployee();
        },
        error: function (paramError) {
          alert("Xóa phòng ban thất bại, vui lòng thử lại");
          $("#modal-delete-department").modal("hide");
          console.log(paramError.status);
        }
      });
    }

    // Hàm reset form tạo mới phòng ban
    function resetFormCreateNewDepartment() {
      $("#inp-department-code-add").val("");
      $("#inp-department-name-add").val("");
      $("#inp-major-add").val("");
      $("#inp-introduce-add").val("");
    }

    // Hàm lấy thông tin nhân viên thêm mới
    function getEmployeeDataForm(paramEmployeeData) {
      paramEmployeeData.employeeCode = $("#inp-employee-code").val().trim();
      paramEmployeeData.employeeName = $("#inp-employee-name").val().trim();
      paramEmployeeData.position = $("#inp-position").val().trim();
      paramEmployeeData.gender = $("#select-gender").val();
      // Vì lúc nhập vào đã sửa lại format của ngày tháng nên h phải trả lại như cũ thì ms post api đc
      var vDataOfBirth = $("#inp-date-of-birth").val();
      paramEmployeeData.dateOfBirth = formatDate(vDataOfBirth);
      paramEmployeeData.phoneNumber = $("#inp-phone-number").val().trim();
      paramEmployeeData.address = $("#inp-address").val().trim();
    }

    // Hàm kiểm tra đã chọn phòng ban hay chưa
    function checkSelectDepartment() {
      var vDepartmentId = $("#select-department").val();
      if (vDepartmentId == "none") {
        alert("Vui lòng chọn phòng ban");
        return false;
      }
      else {
        gDepartmentId = vDepartmentId;
        return true;
      }
    }

    // Hàm validate dữ liệu employee
    function validateEmployeeData(paramEmployeeData) {
      if (paramEmployeeData.employeeCode == "") {
        alert("Vui lòng nhập mã nhân viên!");
        return false;
      }
      // Gọi hàm kiểm tra xem mã nhân viên có bị trùng hay không
      if (checkDuplicateEmployeeCode(paramEmployeeData.employeeCode)) {
        alert("Mã nhân viên đã tồn tại!");
        return false;
      }


      if (paramEmployeeData.employeeName == "") {
        alert("Vui lòng nhập tên nhân viên!");
        return false;
      }
      if (paramEmployeeData.position == "") {
        alert("Vui lòng nhập vị trí!");
        return false;
      }
      if (paramEmployeeData.gender == "") {
        alert("Vui lòng nhập giới tính!");
        return false;
      }

      if (paramEmployeeData.dateOfBirth == "undefined-undefined-") {
        alert("Vui lòng nhập ngày tháng năm sinh!");
        return false;
      }

      if (paramEmployeeData.address == "") {
        alert("Vui lòng nhập địa chỉ nhân viên!");
        return false;
      }

      if (paramEmployeeData.phoneNumber == "") {
        alert("Vui lòng nhập số điện thoại nhân viên!");
        return false;
      }

      if (paramEmployeeData.phoneNumber.length != 10) {
        alert("Số điện thoại phải có 10 chữ số!");
        return false;
      }
      // Gọi hàm kiểm tra xem số điện thoại có bị trùng hay không
      if (checkDuplicatePhoneNumber(paramEmployeeData.phoneNumber)) {
        alert("Số điện thoại bị trùng với 1 nhân viên khác!");
        return false;
      }
      return true;
    }

    // Hàm gọi API để thêm mới 1 nhân viên
    function callApiToCreateNewEmployee(paramEmployeeData) {
      $.ajax({
        type: "POST",
        url: "http://localhost:8080/department/" + gDepartmentId + "/employees",
        contentType: "application/json",
        data: JSON.stringify(paramEmployeeData),
        success: function (paramRes) {
          alert("Thêm nhân viên thành công!");
          // load lại danh sách nhân viên phòng ban đó đưa vào table
          // Lấy danh sách toàn bộ nhân viên
          callApiToGetListEmployee();
          // Reset lại form
          resetFormEmployee();
        },
        error: function (paramError) {
          alert("Thêm mới nhân viên thất bại, vui lòng thử lại!");
          console.log(paramError.status);
        }
      });
    }

    // Hàm gọi API để cập nhật thông tin 1 nhân viên
    function callApiToUpdateEmployee(paramEmployeeData) {
      $.ajax({
        type: "PUT",
        url: "http://localhost:8080/department/" + gDepartmentId + "/employee/" + gEmployeeId,
        contentType: "application/json",
        data: JSON.stringify(paramEmployeeData),
        success: function (paramRes) {
          alert("Cập nhật thông tin nhân viên thành công!");
          // load lại danh sách nhân viên phòng ban đó đưa vào table
          // Lấy danh sách toàn bộ nhân viên
          callApiToGetListEmployee();
          // Reset lại form
          resetFormEmployee();

        },
        error: function (paramError) {
          alert("Cập nhật thông tin nhân viên thất bại, vui lòng thử lại!");
          console.log(paramError.status);
        }
      });
    }

    // Hàm kiểm tra có trùng Department code hay không
    function checkDuplicateDepartmentCode(paramDepartmentCode) {
      var vIndex = 0;
      var vDuplicated = false;
      while (vIndex < gListDepartment.length) {
        if (gListDepartment[vIndex].departmentCode == paramDepartmentCode && gActionDepartment == gACTION_CREATE) {
          return true;
        }
        else if(gListDepartment[vIndex].departmentCode == paramDepartmentCode && gActionDepartment == gACTION_UPDATE && gListDepartment[vIndex].id != gDepartmentId) {
          return true;
        }
        else {
          vIndex++;
        }
      }
      return vDuplicated;
    }

    // Hàm kiểm tra mã nhân viên đã tồn tại hay chưa
    function checkDuplicateEmployeeCode(paramEmployeeCode) {
      var vIndex = 0;
      var vDuplicated = false;
      while (vIndex < gListEmployee.length) {
        // Nếu hành động thực hiện là tạo thì trả về true và có 1 code khác trùng thì trả về true
        if (gListEmployee[vIndex].employeeCode == paramEmployeeCode && gActionEmployee == gACTION_CREATE) {
          return true;
        }
        // Nếu hành động thực hiện là update mà có 1 code khác trùng nhưng khác vs ID cập nhật thì trả về true 
        else if(gListEmployee[vIndex].employeeCode == paramEmployeeCode && gActionEmployee == gACTION_UPDATE && gListEmployee[vIndex].id != gEmployeeId)
        {
          return true;
        }
        else {
          vIndex++;
        }
      }
      return vDuplicated;
    }

    // Hàm kiểm tra số điện thoại nhân viên có bị trùng hay không
    function checkDuplicatePhoneNumber(paramPhoneNumber) {
      var vIndex = 0;
      var vDuplicated = false;
      while (vIndex < gListEmployee.length) {
        // Nếu hành động thực hiện là tạo thì trả về true và có SĐT khác trùng thì trả về true
        if (gListEmployee[vIndex].phoneNumber == paramPhoneNumber && gActionEmployee == gACTION_CREATE) {
          return true;
        }
        // Nếu hành động thực hiện là update mà có 1 SĐT khác trùng nhưng khác vs ID cập nhật thì trả về true 
        else if(gListEmployee[vIndex].phoneNumber == paramPhoneNumber && gActionEmployee == gACTION_UPDATE && gListEmployee[vIndex].id != gEmployeeId)
        {
          return true;
        }
        else {
          vIndex++;
        }
      }
      return vDuplicated;
    }

    // Hàm reset form employee
    function resetFormEmployee() {
      $("#inp-employee-code").val("");
      $("#inp-employee-name").val("");
      $("#inp-position").val("");
      $("#select-gender").val("none");
      $("#inp-date-of-birth").val("");
      $("#inp-phone-number").val("");
      $("#inp-address").val("");
      $("#select-department").val("none");
    }

  </script>
</body>

</html>